/***********************************************************
*                       pC/OS 1.68a                        *
*                      a FREE - RTOS                       *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                      AVR32_INTs.h                        *
*           Atmel AVR32 AT32UC3A1512 Specific Code         *
*                                                          *
***********************************************************/
#ifdef __GNUC__
 #define __interrupt __attribute__((__naked__))
#endif
typedef void (__interrupt *INT_handler)(void);

/***********************************************************
* normally you can have max 64 * 32 interrupt-sources ...
  ... and this needs on 4 bytes per handler 8kB-RAM as table
* if you reduce the table up to max possible sources ...
  ... for your hardware you can save memory 
  (on AT32UC3UC3xxx 1280Byte needed)
* or you creates a structs-in-struct table with spezific ...
  ... lines per possible group - but how it's to control ?
***********************************************************/

#define AVR32_INT_MAX_GRP  20  // AVR32_INTC_NUM_INT_GRPS = 64
#define AVR32_INT_MAX_REQ  16  //                           32

void INT_Init(void);
unsigned char INT_RegHandler(INT_handler handler, unsigned int int_nr, unsigned int lev);


